/*
 * SMS Plus! for the Dreamcast (Sega Master System emulator for the Dreamcast)
 * Original code Copyright (C) 1998, 1999, 2000 Charles Mac Donald
 * Dreamcast port Copyright (C) 2001 Steven Harris (ss_teven)
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */


/*
 * This is very nasty code, some parts uncommented,
 * some are just plain ugly, beware!
 *
 * we use the TA to stretch it to full screen
 * sound is perfect only when 60fps..
 * autoframeskip needs to be implemented
 *
 *          - ss_teven
 */

#include <kos.h>

#include "pcx.h"
#include "font.h"

#include "sndstream.h"

#include "draw.h"
#include "dcVideo.h"
#include "dcp/dcp_image.h"
#include "bitmap.h"
#include "font.h"
#include "smsplus.h"
#include "shared.h"
#include "dc.h"
#include "dt.h"
#include "sq.h"

#include "vmu_icon.h"

int sample_rate = 44100;
void* kos_audio_callback(int size);
int osd_start_audio_stream(int stereo);
void osd_stop_audio_stream(void);
int osd_update_audio_stream(INT16 *buffer);
void osd_set_mastervolume(int _attenuation);
int osd_get_mastervolume(void);
void osd_sound_enable(int enable_it);
void osd_opl_control(int chip,int reg);
void osd_opl_write(int chip,int data);

static uint8 mcont1 = 0;
static uint8 mcont2 = 0;
static uint8 mkeyb1 = 0;
static uint8 mvmu1 = 0;
uint8 *splash;

int do_disp(void);
void disclaimer();

/* store queues stuff, thanks joey and regex */
typedef unsigned short zword;
typedef unsigned       zdword;
void doPrestore(uint32 addr);
void sqmemcpy(void *dest, void *src);
zword lookupDiv[256];
char *arrow;
char *space;

void draw_string_center(float y, float z, float a, float r, float g, float b, char *str, float xs, float ys);
void draw_stringf(float x, float y, float z, float a, float r, float g, float b, float xs, float ys, char *fmt, ...);
void draw_string(float x, float y, float z, float a, float r, float g, float b, char *str, float xs, float ys);
void draw_char(float x1, float y1, float z1, float a, float r, float g, float b, int c, float xs, float ys);
void draw_color_rect(int x, int y, int w, int h, float a, float r, float g, float b, float z, int trans);
void font_init(void);
long rnc_unpack (void *packed, void *unpacked);
int jjpeg_to_texture(char * filename, unsigned short *tex, int n, int scale);

uint32 texture=0;
uint32 texture_pool = 0x700000; /* Safe space in TA buffer for allocating textures */
uint32 texture_alloc(uint32 size) {
        uint32 rv = texture_pool;

        /* Align to 8 bytes */  
        size = (size + 7) & (~7);
        texture_pool += size;
        
        return rv;
}

typedef struct {
	float	x, y, z;
        float   u, v;
	float	dx, dy;
} polyplace_t;
polyplace_t polys = { 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 3.0f, 5.0f };
static uint32 disc_txr;
static uint32 gui_txr;
static void disc_blank();
static void disc_display(polyplace_t *p);
static void gui_txr_display(float fade, polyplace_t *p);
void bkg_init();
void draw_background();
extern uint32 util_texture;

int frameskip=4;
int frameskip_setting=0,time_frameskip=-1,nb_frames=0,frameskip_delay=0;
int use_auto_frameskip=1, use_sound=1, use_antialias=1;
uint16 *txrtmp;
uint16 *guitxrtmp;

/* settings and vmu stuff */
#include "vmu.h"
void load_default_settings();
//save_user_settings(vmu_mem1);
user_settings settings;
t_rom ROM;


typedef struct {
    unsigned long int crc;
    char *filename;
    char *name;
} t_smscrc;

t_smscrc smscrc_list[] = {
    {0xE843BA7E, "/rd/E843BA7E.jpg", "Bubble Bobble"},
};

#include "loadjpeg.h"
uint32 bkg_tex;
int bkg_set;
void bkg_init(char *fileload) {
	uint16 *tex;
        bkg_tex = ta_txr_allocate(1024*512*2);
        tex = ta_txr_map(bkg_tex);
        memset(tex, 0, 1024*512*2);
        jjpeg_to_texture(fileload, tex, 1024, 1);
}
uint32 covertxr;
void draw_jpgcvr();
void jpegcover(char *fileload) {
        uint16 *tex;
        poly_hdr_t poly;
        //float x = 0.0f, y = 0.0f, w = 640.0f, h = 480.0f;
        //vertex_ot_t vert;

        covertxr = ta_txr_allocate(512*512*2);
        tex = ta_txr_map(covertxr);
        memset(tex, 0, 512*512*2);
        jjpeg_to_texture(fileload, tex, 512, 1);
        ta_poly_hdr_col(&poly, TA_TRANSLUCENT);
        ta_begin_render(); draw_jpgcvr();
        ta_commit_eol();
        ta_commit_poly_hdr(&poly); ta_commit_eol();
        ta_finish_frame();
}
void draw_jpgcvr() {
        float x = 0.0f, y = 0.0f, w = 640.0f, h = 480.0f;
        vertex_ot_t vert;
        poly_hdr_t poly;

        ta_poly_hdr_txr(&poly, TA_OPAQUE, TA_RGB565, 512, 512, covertxr, TA_BILINEAR_FILTER);
        ta_commit_poly_hdr(&poly);

        vert.flags = TA_VERTEX_NORMAL;
        vert.x = x;
        vert.y = y+h-1;
        vert.z = 5.0f;
        vert.a = vert.r = vert.g = vert.b = 1.0f;
        vert.oa = vert.or = vert.og = vert.ob = 0.0f;
        vert.u = 0.0f; vert.v = 1.0f;
        ta_commit_vertex(&vert, sizeof(vert));

        vert.y = y;
        vert.v = 0.0f;
        ta_commit_vertex(&vert, sizeof(vert));

        vert.x = x+w-1;
        vert.y = y+h-1;
        vert.u = 1.0f; vert.v = 1.0f;
        ta_commit_vertex(&vert, sizeof(vert));
	
        vert.flags = TA_VERTEX_EOL;
        vert.y = y;
        vert.v = 0.0f;
        ta_commit_vertex(&vert, sizeof(vert));
}

/* Draw a polygon for a shaded box; wow, a nasty looking func =) */
void draw_poly_box(float x1, float y1, float x2, float y2, float z,
		float a1, float r1, float g1, float b1,
		float a2, float r2, float g2, float b2) {

        return;
}

extern uint8 romdisk_boot[];
int main (int argc, char **argv) {
        int z=0,y;
        snd.enabled = 0;
        sms.use_fm = 0;

        kos_init_all(IRQ_ENABLE | THD_ENABLE | TA_ENABLE, romdisk_boot);

        frame_skip = max_skip;

        init_machine();

        gui_txr = ta_txr_allocate(1024*512*2);
        disc_txr = gui_txr;

        /* this should speed some stuff up quite a bit */
	for (y = 0; y < 256; y++)
		lookupDiv[y] = 256*(y+(y/15));

        frame_count = 0;

        txrtmp = (uint16*)ta_txr_map(disc_txr);
        guitxrtmp = (uint16*)ta_txr_map(gui_txr);

        load_default_settings();

        while(z==0) z=emuloop();

        system_shutdown();
        trash_machine();

        return (0);
}


int emuloop() {
        int x, mm;
/*
        //dc_print("this is a TEST");
        bfont_draw_str(guitxrtmp + 20*512+20, 512, 0, "this is a TEST");
        //disclaimer();
        ta_begin_render();
        gui_txr_display(1.0f, &polys);
        ta_commit_eol();
        disc_blank();
        ta_commit_eol();
        ta_finish_frame();
        //ta_txr_release_all();

        //thd_sleep(2000);
*/

        mm = SELECT_ROM;//MAIN_MENU
        while(1) {
                x=draw_gui(mm);//SELECT_ROM
                if(x==SELECT_ROM) mm = SELECT_ROM;
                if(x==MAIN_MENU) mm = MAIN_MENU;
                if(x==EXIT_MENU) break;
        }
        if(x==1) return 0;
        if(snd.enabled) {
                system_init(44100);
        } else {
                system_init(0);
        }
        load_sram();
        if(snd.enabled) {
                if (kos_stream_init(kos_audio_callback) < 0) {
                        dc_print("audio stream error");
                        thd_sleep(1500);
                        exit_flag = 1;
                }
                osd_start_audio_stream(1);
        }

        /* Main emulation loop */
        for(;;) {

                /* Exit if exit_flag has been set */
                if(exit_flag) break;

                /* Bump frame count */
                frame_count++;

                /* Frame skip */


                if(frame_count % frame_skip == 0) {
                        skip_flag = 0;
                } else {
                        skip_flag = 1;
                }

                /* Get current input */
                update_input();

                /* Run the system emulation for a frame */
                sms_frame(skip_flag);

                /* Update the display/audio */
                if(snd.enabled)
                        osd_update_audio_stream(&snd.buffer[0][0]);

                if(skip_flag == 0) {
                        update_video();
                        disclaimer();
                }
        }

        save_sram();
        clearscr(640,480);
        thd_sleep(50);
        sms_reset();
        if(cart.zip) {
                free(f->data);
                free(f->filename);
                free(f);
        }
        free(cart.rom);
        spu_disable();
        stream_stop();
        exit_flag=0;
        thd_sleep(450);
        return(0);
}

void load_default_settings() {
        settings.frame_skip = 4;
	settings.sound_on = TRUE;
	settings.save = FALSE;
}

static void gui_txr_display(float fade, polyplace_t *p) {
	poly_hdr_t	hdr;
        vertex_ot_t     vert;

	if (fade < 0.0f) fade = 0.0f;

        //ta_poly_hdr_col(&hdr, TA_OPAQUE);
        ta_poly_hdr_txr(&hdr, TA_OPAQUE, TA_RGB565, 512, 512, gui_txr, TA_NO_FILTER);
        ta_commit_poly_hdr(&hdr);

        vert.flags = TA_VERTEX_NORMAL;      //480
        vert.x = p->x + 0.0f; vert.y = p->y + 480.0f; vert.z = p->z;
        vert.a = 1.0f; //vert.r = 0.0f; vert.g = 0.0f; vert.b = 0.0f;
        vert.r = vert.g = vert.b = fade;
        vert.u = 0.0f; vert.v = 1.0f;
        ta_commit_vertex(&vert, sizeof(vert));

	vert.flags = TA_VERTEX_NORMAL;
        vert.x = p->x + 0.0f; vert.y = p->y + 0.0f; vert.z = p->z;
        vert.a = 1.0f; //vert.r = 0.0f; vert.g = 0.0f; vert.b = 0.0f;
        vert.u = 0.0f; vert.v = 0.0f;
        ta_commit_vertex(&vert, sizeof(vert));

	vert.flags = TA_VERTEX_NORMAL;
                      //640                   //480
        vert.x = p->x + 640.0f; vert.y = p->y + 480.0f; vert.z = p->z;
        vert.a = 1.0f; //vert.r = 0.0f; vert.g = 0.0f; vert.b = 0.0f;
        vert.u = 1.0f; vert.v = 1.0f;
        ta_commit_vertex(&vert, sizeof(vert));

	vert.flags = TA_VERTEX_EOL;
                      //640
        vert.x = p->x + 640.0f; vert.y = p->y + 0.0f; vert.z = p->z;
        vert.a = 1.0f;// vert.r = vert.g = vert.b = fade;//vert.r = 0.0f; vert.g = 0.0f; vert.b = 0.0f;
        vert.u = 1.0f; vert.v = 0.0f;
        ta_commit_vertex(&vert, sizeof(vert));
}

void dc_dstring (int x, float r, float g, float b, char *fmt, ...) {
	va_list		args;
	char		pbuf[2048];
	va_start(args, fmt);
	vsprintf(pbuf, fmt, args);
	va_end(args);
        draw_string(170, x, 6.0f, 1.0f, r, g, b, pbuf, 1.5f, 1.5f);
        //bfont_draw_str(uitxrtmp + 400*640+20, 640, 0, pbuf);
}

void draw_stringf(float x, float y, float z, float a, float r, float g, float b, float xs, float ys, char *fmt, ...) {
	va_list		args;
	char		pbuf[2048];
        va_start(args, fmt);
        vsprintf(pbuf, fmt, args);
	va_end(args);
        draw_string(x, y, z, a, r, g, b, pbuf, xs, ys);
}

void list_menu(int a) {
//space , arrow
        if (a == 0) {
                dc_dstring(200, 0.0f, 0.0f, 0.0f, "%s Load Rom", arrow);
        } else {
                dc_dstring(200, 0.0f, 0.0f, 0.0f, "%s Load Rom", space);
        }
        if (a == 1) {
                dc_dstring(225, 0.0f, 0.0f, 0.0f, "%s Continue", arrow);
        } else {
                dc_dstring(225, 0.0f, 0.0f, 0.0f, "%s Continue", space);
        }
        if (a == 2) {
                dc_dstring(250, 0.0f, 0.0f, 0.0f, "%s Options", arrow);
        } else {
                dc_dstring(250, 0.0f, 0.0f, 0.0f, "%s Options", space);
        }
        if (a == 3) {
                dc_dstring(275, 0.0f, 0.0f, 0.0f, "%s About", arrow);
        } else {
                dc_dstring(275, 0.0f, 0.0f, 0.0f, "%s About", space);
        }
}

int draw_gui(int o) {
        //int     i, x, y = (480 - 9*24)/2;
        int setbrk;

        //o=MAIN_MENU;

        if(o == MAIN_MENU) {
                poly_hdr_t npoly;
                int a,b;
//void draw_color_rect(int x, int y, int w, int h, float a, float r, float g, float b, float z, int trans)
                for(a=0;a<120;a++) {
                        poly_hdr_t poly;
                        ta_poly_hdr_col(&poly, TA_TRANSLUCENT);
                        ta_begin_render();
                        draw_background();
                        ta_commit_eol();
                        draw_color_rect(165, 190, 150, a, 0.2f, 0.3f, 0.0f, 1.0f, 5.1f, 1);
                        ta_commit_poly_hdr(&poly);
                        ta_commit_eol();
                        ta_finish_frame();
                        thd_sleep(3);
                }
                b=0;
                setbrk = 0;
                while(setbrk == 0) {
                        cont_cond_t FirstCont;
                        int FirstKeyb;
                        ta_poly_hdr_col(&npoly, TA_TRANSLUCENT);
                        ta_begin_render();
                        draw_background();
                        ta_commit_eol();
                        draw_color_rect(165, 190, 150, a, 0.2f, 0.3f, 0.0f, 1.0f, 5.1f, 1);
                        list_menu(b);
                        ta_commit_poly_hdr(&npoly);
                        ta_commit_eol();
                        ta_finish_frame();

                        ta_begin_render();
                        draw_background();
                        ta_commit_eol();
                        draw_color_rect(165, 190, 150, a, 0.2f, 0.3f, 0.0f, 1.0f, 5.1f, 1);
                        list_menu(b);
                        ta_commit_poly_hdr(&npoly);
                        ta_commit_eol();
                        ta_finish_frame();

                        FirstCont=getButtons(0);
                        FirstKeyb=getKeys();

                        if(FirstCont.ltrig & FirstCont.rtrig) setbrk = 1;
                        if(!(FirstCont.buttons & CONT_DPAD_UP)) { b--; if (b<0) b=3; }
                        if(!(FirstCont.buttons & CONT_DPAD_DOWN)) { b++; if (b>=4) b=0; }
                        if(FirstKeyb == 20992) { b--; if (b<0) b=3; }
                        if(FirstKeyb == 20736) { b++; if (b>=4) b=0; }
                        if(FirstKeyb == 27) setbrk = 1;
                        thd_sleep(150);
                }
                thd_sleep(2000);
                return(MAIN_MENU);
        } else if(o == SELECT_ROM) {
                //strcpy(dir_root,defdir);
                //strcpy(pdir[0],dir_root);
                select_rom();
                return(EXIT_MENU);
        }

        return(MAIN_MENU);
}

/* Song menu choices */
typedef struct {
	char	fn[16];
	int	size;
} entry;
char curdir[64] = "/cd";

#define DC_MAX_FILES 1000
static entry entries[DC_MAX_FILES];

static int num_entries = 0, load_queued = 0;
static int selected = 0, top = 0;

static int framecnt = 0;
static float throb = 0.2f, dthrob = 0.01f;

static void load_song_list() {
	file_t d;

	d = fs_open(curdir, O_RDONLY | O_DIR);
	if (!d) {
                strcpy(curdir, "/cd");
		d = fs_open(curdir, O_RDONLY | O_DIR);
		if (!d) {
			num_entries = 1;
			strcpy(entries[0].fn,"Error!");
			entries[0].size = 0;
			return;
		}
	}
	{
		dirent_t *de;
		num_entries = 0;
                if (strcmp(curdir, "/cd")) {
			strcpy(entries[0].fn, "<..>"); entries[0].size = -1;
			num_entries++;
		}
                while ( (de = fs_readdir(d)) && num_entries < DC_MAX_FILES) {
                        //printf("read entry '%s'\n", de->name);
                        if((de->size<0) || (strcmp(&de->name[strlen(de->name)-3],"ZIP")==0) || (strcmp(&de->name[strlen(de->name)-3],"zip")==0) || (strcmp(&de->name[strlen(de->name)-2],"GG")==0) || (strcmp(&de->name[strlen(de->name)-2],"gg")==0) || (strcmp(&de->name[strlen(de->name)-3],"SMS")==0) || (strcmp(&de->name[strlen(de->name)-3],"sms")==0)) {
                                strcpy(entries[num_entries].fn, de->name);
                                entries[num_entries].size = de->size;
                                num_entries++;
                        }
		}
	}
	fs_close(d);
}

/* Draws the song listing */
//260x50
static void draw_listing() {
        float y = 50.0f;
	int i, esel;

	/* Draw all the song titles */	
	for (i=0; i<14 && (top+i)<num_entries; i++) {
                draw_string(260.0f, y, 100.0f, 1.0f, 1.0f, 1.0f, 1.0f, entries[top+i].fn, 1.5f, 1.5f);
                //draw_poly_strf(32.0f, y, 100.0f, 1.0f, 1.0f, 1.0f, 1.0f, entries[top+i].fn);
		if (entries[top+i].size >= 0) {
                        draw_stringf(260.0f+180.0f, y, 100.0f, 1.0f, 1.0f, 1.0f, 1.0f, 1.5f, 1.5f, "%d bytes", entries[top+i].size);
//                        draw_poly_strf(32.0f+180.0f, y, 100.0f, 1.0f, 1.0f, 1.0f, 1.0f,
//                                "%d bytes", entries[top+i].size);
		} else {
                        draw_string(260.0f+180.0f, y, 100.0f, 1.0f, 1.0f, 1.0f, 1.0f, "<DIR>", 1.5f, 1.5f);
                        //draw_poly_strf(32.0f+180.0f, y, 100.0f, 1.0f, 1.0f, 1.0f, 1.0f, "<DIR>");
		}
		y += 24.0f;
	}
	
	/* Put a highlight bar under one of them */
	esel = (selected - top);
        draw_string(260.0f, 50.0f+esel*24.0f, 100.0f, 1.0f, 1.0f, 0.0f, 1.0f, entries[selected].fn, 1.5f, 1.5f);
        //draw_poly_box(31.0f, 82.0f+esel*24.0f - 1.0f,
        //        609.0f, 82.0f+esel*24.0f + 25.0f, 95.0f,
        //        throb, throb, 0.2f, 0.2f, throb, throb, 0.2f, 0.2f);
}

/* Handle controller input */
int check_controller() {
	static uint8 mcont = 0;
	static int up_moved = 0, down_moved = 0;
	cont_cond_t cond;

	if (!mcont) {
		mcont = maple_first_controller();
                if (!mcont) { return 0; }
	}
        if (cont_get_cond(mcont, &cond)) { return 0; }

	if (!(cond.buttons & CONT_DPAD_UP)) {
		if ((framecnt - up_moved) > 10) {
			if (selected > 0) {
				selected--;
				if (selected < top) {
					top = selected;
				}
			}
			up_moved = framecnt;
		}
	}
	if (!(cond.buttons & CONT_DPAD_DOWN)) {
		if ((framecnt - down_moved) > 10) {
			if (selected < (num_entries - 1)) {
				selected++;
				if (selected >= (top+14)) {
					top++;
				}
			}
			down_moved = framecnt;
		}
	}
	if (cond.ltrig > 0) {
		if ((framecnt - up_moved) > 10) {
			selected -= 14;
			if (selected < 0) selected = 0;
			if (selected < top) top = selected;
			up_moved = framecnt;
		}
	}
	if (cond.rtrig > 0) {
		if ((framecnt - down_moved) > 10) {
			selected += 14;
			if (selected > (num_entries - 1))
				selected = num_entries - 1;
			if (selected >= (top+14))
				top = selected;
			down_moved = framecnt;
		}
	}
        if (!(cond.buttons & CONT_Y)) {
                uint32 hnd;
                int i;

                hnd = fs_open(curdir, O_RDONLY | O_DIR);
                fs_ioctl(hnd, NULL, 0);
                fs_close(hnd);

                strcpy(curdir, "/cd");

                for (i=0; i<DC_MAX_FILES; i++) {
                        strcpy(entries[i].fn,NULL);
                        entries[i].size = 0;
                }

                load_song_list();
        }
	if (!(cond.buttons & CONT_A)) {
                thd_sleep(200);
		if (!strcmp(entries[selected].fn, "Error!")) {
			num_entries = 0;
			load_song_list();
		} else if (entries[selected].size >= 0) {
                        int n,x;
                        char *t_filename;
                        t_filename=malloc(4086*10);
                        //play_s3m(entries[selected].fn, curdir);
                        strcpy(t_filename, curdir);
                        strcat(t_filename, "/");
                        strcat(t_filename, entries[selected].fn);
                        x=load_rom(t_filename);
                        for(n = 0; n < (sizeof(smscrc_list) / sizeof(t_smscrc)); n += 1) {
                                if(cart.crc == smscrc_list[n].crc) {
                                        jpegcover(smscrc_list[n].filename);
                                        dc_print(smscrc_list[n].name);
                                        thd_sleep(2000);
                                }
                        }
                        free(t_filename);
                        return x;
		} else {
			if (!strcmp(entries[selected].fn, "<..>")) {
				int i;
				for (i=strlen(curdir); i>0; i--) {
					if (curdir[i] == '/') {
						curdir[i] = 0;
						break;
					} else
						curdir[i] = 0;
				}
			} else {
				if (strcmp(curdir, "/"))
					strcat(curdir, "/");
				strcat(curdir, entries[selected].fn);
			}
			selected = top = num_entries = 0;
			printf("current directory is now '%s'\n", curdir);
			load_song_list();
		}
	}
        return 0;
}

/* Main rendering of the song menu */
void song_menu_render() {
	/* Draw a background box */
        //draw_poly_box(30.0f, 70.0f, 610.0f, 430.0f, 90.0f, 
        //        0.2f, 0.8f, 0.5f, 0.0f, 0.2f, 0.8f, 0.8f, 0.2f);
        //draw_poly_box(30.0f, 70.0f, 610.0f, 430.0f, 90.0f, 
        //        0.2f, 0.3f, 0.0f, 1.0f, 0.2f, 0.8f, 0.8f, 0.2f);
//
	/* If we don't have a file listing, get it now */
	if (num_entries == 0) {
		if (load_queued < 4) {
//void draw_string(float x, float y, float z, float a, float r, float g, float b, char *str, float xs, float ys);
                                //  32.0f  82.0f
                        draw_string(260.0f, 50.0f, 100.0f, 1.0f, 1.0f, 1.0f, 1.0f, "Scanning Directory...", 1.5f, 1.5f);
                        //draw_poly_strf(32.0f, 82.0f, 100.0f, 1.0f, 1.0f, 1.0f, 1.0f, "Scanning Directory...");
			load_queued++;
			return;
		} else {
			load_song_list();
			load_queued = 0;
		}
	}
	
	/* Draw the song listing */
	draw_listing();
	
	/* Adjust the throbber */
	throb += dthrob;
	if (throb < 0.2f || throb > 0.8f) {
		dthrob = -dthrob;
		throb += dthrob;
	}
	
	framecnt++;
}

char *cscroll[] = {
"",
"",
"",
"",
"Credits",
"",
"",
"Dan Potter",
"Sayten",
"Heliophobe",
"ReGex",
"crt0",
"DCGrendel",
"|joey|",
"",
"All the beta",
"testers",
"",
""
};

int select_rom() {
        while(!check_controller()) {
		ta_begin_render();
                display_dcp(splash);
		ta_commit_eol();
		song_menu_render();
		ta_commit_eol();
		ta_finish_frame();
        }

        return(0);
}

int draw_list(int selected, int total, int maxi, int mini) {
        //int i,x,y = (480 - 9*24)/2;
        int i,y = (512 - 9*24)/2;
        //uint16 *uitxrtmp;
        //display_dcp(splash);
        //uitxrtmp = (uint16*)ta_txr_map(gui_txr);
    poly_hdr_t poly;

    ta_poly_hdr_col(&poly, TA_TRANSLUCENT);

    ta_begin_render();

        draw_background();

    ta_commit_eol();
        //draw_color_rect(8, 60, 616, 400, 0.2f, 0.3f, 0.0f, 1.0f, 5.1f, 1);

//        draw_string_center(16, 6.0f, 1.0f, 0.0f, 0.0f, 0.0f, "MP3 Jukebox", 1.5f, 1.5f);
//id draw_string_center(flt y, ft z, ft a, ft r, ft g, ft b, char *strdfsd, f xs, f ys)

        for(i=mini;i<total;i++) {
                char *temp;
                temp=malloc(512);
                if(i==selected) {
                        //bfont_printf(guitxrtmp + y*512+(x-24), 512, "[ %s ]", game_desc[i]);
                        sprintf(temp,"[ %s ]",game_desc[i]);
                        draw_string_center(y, 6.0f, 1.0f, 0.0f, 0.0f, 0.0f, temp, 1.5f, 1.5f);
                } else {
                        //bfont_printf(guitxrtmp + y*512+x, 512, game_desc[i]);
                        strcpy(temp,game_desc[i]);
                        draw_string_center(y, 6.0f, 1.0f, 0.0f, 0.0f, 0.0f, temp, 1.5f, 1.5f);
                }
                y += 27;
                free(temp);
        }
    ta_commit_poly_hdr(&poly);

    ta_commit_eol();
    ta_finish_frame();
        return 0;
}

void bfont_printf(uint16 *buffer, int width, char *fmt, ...) {
	va_list		args;
	char		pbuf[2048];

	va_start(args, fmt);
	vsprintf(pbuf, fmt, args);
	va_end(args);

        bfont_draw_str(buffer, width, 0, pbuf);
}

char return_hex_char_32 (uint32 val);
uint32 return_1_byte (uint32 val, int position);

void dc_print (char *fmt, ...) {
	va_list		args;
	char		pbuf[2048];
        poly_hdr_t poly;
	va_start(args, fmt);
	vsprintf(pbuf, fmt, args);
	va_end(args);
        ta_poly_hdr_col(&poly, TA_TRANSLUCENT);
        ta_begin_render();
        draw_background();
        ta_commit_eol();
        draw_string(20, 400, 6.0f, 1.0f, 0.0f, 0.0f, 0.0f, pbuf, 1.5f, 1.5f);
        printf("%s\r\n",pbuf);
        //bfont_draw_str(uitxrtmp + 400*640+20, 640, 0, pbuf);
        ta_commit_poly_hdr(&poly);
        ta_commit_eol();
        ta_finish_frame();
}

void dc_sleep (uint32 time) {
        thd_sleep(time);
}

void print_uint32 (uint32 val) {
	uint32 temp, temp2;
	char val_32[9];
        int i;
        poly_hdr_t poly;

        ta_poly_hdr_col(&poly, TA_TRANSLUCENT);
        ta_begin_render();
        draw_background();
        ta_commit_eol();
        //bfont_draw_str(uitxrtmp + 400*640+20, 640, 0, pbuf);
        for (i=0; i < 8; i++) {
		temp2 = val;
		temp = return_1_byte (temp2, i);
		val_32[7-i] = return_hex_char_32 (temp); 
	}
	val_32[8] = '\0';
        //draw_string (20, 20, 255, val_32);
        draw_string(20, 400, 6.0f, 1.0f, 0.0f, 0.0f, 0.0f, val_32, 1.5f, 1.5f);
        printf("%s\r\n",val_32);
        ta_commit_poly_hdr(&poly);
        ta_commit_eol();
        ta_finish_frame();
        thd_sleep(3000);
}


/* csleep(int sleep, uint16 pbutton);  okay, now I hated that i
 * couldnt flash a message with it sleeping for 500ms, in that 500ms
 * sleep someone may have pushed a button or something, so what this
 * baby does is sleeps for 1ms and after each 1ms it searches for the
 * controller, and then sleeps for 1ms again, until the designated
 * sleep number is done then it breaks out and returns 0, or if the
 * button is pressed then it breaks out of the loop and returns 1
 */
int csleep(int slp, uint16 pbutton) {
   int s=1,a=0;
   cont_cond_t mcond;

   while(1) {
          s++;
          if(cont_get_cond(maple_first_controller(), &mcond)) {
             return 0;
          }
          if(!(mcond.buttons  & pbutton)) {
             a=1;
             break;
          }
          thd_sleep(1);
          if(s==slp) {
             a=0;
             break;
          }
   }
   return(a);
   return(0);
}

int switch_mode(int res) {
        vid_set_mode_and_cable(vid_check_cable(), res, PM_RGB565);
        switch(res) {
                case DM_320x240:
                        SCREEN_W = 320;
                        SCREEN_H = 240;
                        break;
                case DM_640x480:
                        SCREEN_W = 640;
                        SCREEN_H = 480;
                        break;
                case DM_800x608:
                        SCREEN_W = 800;
                        SCREEN_H = 608;
                        break;
        }
        vid_clear(0,0,0);
        return(0);
}

void vmu_display(char * vmuimg) {
        uint8 vmubitmap[48*32/8];
        int x, y, xi, xb;
        memset(vmubitmap, 0, 48*32/8);
	for (y=0; y<32; y++)
		for (x=0; x<48; x++) {
			xi = x / 8;
			xb = 0x80 >> (x % 8);
                        if (vmuimg[(31-y)*48+(47-x)] == '.')
                                vmubitmap[y*(48/8)+xi] |= xb;
		}
	
        vmu_draw_lcd(maple_first_vmu(), vmubitmap);
        return;
}

int init_machine() {
        int i;

        mcont1 = maple_first_controller();
        mvmu1 = maple_first_vmu();
        mkeyb1 = maple_first_kb();

        /* Initialize display bitmap */
        memset(&bitmap, 0, sizeof(t_bitmap));
        bitmap.width  = 256;
        bitmap.height = 192;
        bitmap.depth  = 8;
        bitmap.pitch  = (bitmap.width * (bitmap.depth >> 3));
        bitmap.data   = (unsigned char *)&bitmap_data[0];

        init_smsplus();

        splash=(uint8 *)malloc(480*640*3);
        dcp_load(splash,p_smsplus);

        for (i=0; i<2048; i++) {
                game_desc[i] = (char *)malloc(256);
	}

        dir_root=(char *)malloc(256);

        arrow = malloc(2);
        arrow = "->";
        space = malloc(2);
        space = "  ";

        font_init();
        bkg_init("/rd/bkg.jpg");

        vmu_display(vmu_icon);

        ss_gamegear_w = 160.0f / 256.0f;
        ss_mastersystem_w = 1.0f;
        ss_gamegear = 144.0f / 256.0f;
        ss_mastersystem = 192.0f / 256.0f;

        return(0);
}

void trash_machine(void)
{
        int i;
        free(space);
        free(arrow);
        free(dir_root);
        free(splash);
        for (i=0; i<2048; i++) {
                free(game_desc[i]);
	}
        return;
}

/* startof sound.c */
#include "sndstream.h"

#define AUDIO_BUFFER_SIZE 10000
#define SMOOTH_SIZE 200
#define DC_FRAMES_PER_SECOND 60

int attenuation = 0;
unsigned char *audio_buffer = NULL;
unsigned char *audio_temp = NULL;

static int audio_stereo;
static int audio_pos = 0; // the position of the next buffer in the audio_buffer to be returned by kcallback

/* global sample tracking */
static int samples_per_frame;
static int samples_per_frame_remainder;
static int samples_left_over;
static int samples_this_frame;

// flag to set for callback to return NULL when stopped
static int stopped = 1;

// single linear transition from src to dst values
void audio_smooth_together(INT16 *audio_to_smooth, INT16 *audio_to_match)
{
 INT16 * dst_left;
 INT16 * dst_right;
 INT16 * src_left;
 INT16 * src_right;
int i;

 dst_left = audio_to_smooth;
 dst_right = audio_to_smooth + 1;

 src_left = audio_to_match;
 src_right = audio_to_match + 1;

 for (i = 0; i < SMOOTH_SIZE; i++)
 {
  *dst_left =  (((*src_left * (SMOOTH_SIZE - i)) / SMOOTH_SIZE) + ((*dst_left * (i)) / SMOOTH_SIZE))/2;
  *dst_right =  (((*src_right * (SMOOTH_SIZE - i)) / SMOOTH_SIZE) + ((*dst_right * (i)) / SMOOTH_SIZE))/2;

  dst_left += 2;
  dst_right += 2;
  src_left += 2;
  src_right += 2;
 }
}

// simple linear transition from value to dst
void audio_smooth_to_value(INT16 *audio_to_smooth, INT16 value_to_match)
{
 INT16 * dst_left;
 INT16 * dst_right;
int i;

 dst_left = audio_to_smooth;
 dst_right = audio_to_smooth + 1;

 for (i = 0; i < SMOOTH_SIZE; i++)
 {
  *dst_left =  (((value_to_match * (SMOOTH_SIZE - i)) / SMOOTH_SIZE) + ((*dst_left * (i)) / SMOOTH_SIZE))/2;
  *dst_right =  (((value_to_match * (SMOOTH_SIZE - i)) / SMOOTH_SIZE) + ((*dst_right * (i)) / SMOOTH_SIZE))/2;

  dst_left += 2;
  dst_right += 2;
 }
}

// way to much memory moving around for my taste but...
void* kos_audio_callback(int size)
{
 //int i;

 // return NULL if stopped this will cause the sndstream
 // code to silience the sound hardware on the next poll.
 if (stopped)
 {
  return NULL;
 }

// Jim's magic fairy dust is located here
// we don't have enough new data yet so let's manufature some data
// this is where a smaller buffer would be nice to make matching smoother
// but a smaller buffer means that this will occur more frequently
// so it really needs to do a good job
// even at full speed emulation things can get out of sync and we will
// need to manufacture data sometimes
if (size > audio_pos)
{
 // if it's not too bad let's do something fancy
 // otherwise just return the whole last buffer again cause it
 // will match what we will be playing next
 if (size > 2 * audio_pos + SMOOTH_SIZE)
 {
  // well, we are way behind so just repeat the whole last buffer

  // smooth the BACK to match the front here and avoid the seam
  audio_smooth_to_value(audio_temp, audio_temp[size]);

  return audio_temp;
 }
 else
 {
  // copy what we do have into the end of the buffer
  // cause it will match what will will be playing next
  memcpy(audio_temp + (size - audio_pos), audio_buffer, audio_pos);

  // copy what we do have into the beginning of the buffer
  // cause it matches what we have already played
  // but only enough to meet what we copied above
  // leaving only one small seam
  memcpy(audio_temp, audio_buffer, (size - audio_pos));

  // smooth the FRONT to match the back here and avoid the seam
  audio_smooth_together(audio_temp + (size - audio_pos), audio_buffer + (size - audio_pos));

  // we used up all our data so adjust the position
  // hopefully we will have enough next time
  audio_pos = 0;

  return audio_temp;
 }
}

 // copy current audio data into temp buffer to pass back
 memcpy(audio_temp, audio_buffer, size);

 // adjust the position in the audio buffer
 audio_pos -= size;

 // if it didn't ask for all the data slide back the extra
 // data we have to the front of the audio buffer so
 // we know where it is next time through
 if (audio_pos)
 {
  memcpy(audio_buffer, audio_buffer + size, audio_pos);
 }

 // return the new audio data
 return audio_temp;
}
int osd_start_audio_stream(int stereo)
{
        if (sample_rate == 0) return 0;

	// first time through allocate the buffers
	if (audio_buffer == 0)
	{
		audio_buffer = (char *)malloc(AUDIO_BUFFER_SIZE * 2);
		audio_temp = (char *)malloc(AUDIO_BUFFER_SIZE);
	}

	memset(audio_buffer, 0, AUDIO_BUFFER_SIZE * 2);
	memset(audio_temp, 0, AUDIO_BUFFER_SIZE);

	// initial position in the audio buffer
	audio_pos  = 0;
	audio_stereo = stereo;

	/* determine the number of samples per frame */
        samples_per_frame = sample_rate / DC_FRAMES_PER_SECOND;
        samples_per_frame_remainder = sample_rate % (int)DC_FRAMES_PER_SECOND;
	samples_left_over = samples_per_frame_remainder;
	samples_this_frame = samples_per_frame;

	printf("samples_per_frame: %d\n", samples_per_frame);
	
	// not stopped anymore
	stopped = 0;
	
	// start the audio stream, always stereo
        stream_start(sample_rate, 1);

	// ask for this many samples for the first frame
	return samples_this_frame;
}

void osd_stop_audio_stream(void)
{
        if (sample_rate == 0) return;
	
	if (audio_buffer != 0) 
	{
		// extra space for main buffer in case we get more than a buffer
		memset(audio_buffer, 0, AUDIO_BUFFER_SIZE * 2);
		// buffer that gets transfered to sndstream
		memset(audio_temp, 0, AUDIO_BUFFER_SIZE);
	}

	stopped = 1;
	
	// wait for silience to get transfered to both buffers before we shutdown
	stream_poll();
	
	// stop the stream
	stream_stop();
}

int osd_update_audio_stream(INT16 *buffer)
{
        if (sample_rate == 0) return 0;

	if (audio_stereo)
	{
		// copy the new data into the audio buffer at the current position
		memcpy(audio_buffer + audio_pos, buffer, samples_this_frame * 2);
		audio_pos += samples_this_frame * 2;
	} 
	else 
	{
		int i, j;
		INT16 *p;

		// OK now we have to manufacture stereo data from mono
		i = j = audio_pos / 2;

		p = (INT16 *)audio_buffer;

		for (i = 0; i < samples_this_frame; i++)
		{
			// every other byte
			p[j + (i * 2)]     = *buffer;
			p[j + (i * 2) + 1] = *buffer++;
		}
		
		// and now we have twice the data
		audio_pos += samples_this_frame * 4;
	}
	
	// we have enough data in the buffer so wait for it to be transfered 
	// via the kcallback() before asking for more
//	if (audio_pos >= AUDIO_BUFFER_SIZE) 
	{
		stream_poll();
	}
	
	// update samples to request for next frame
	samples_left_over = samples_left_over + samples_per_frame_remainder;
        samples_this_frame = samples_per_frame +  samples_left_over / DC_FRAMES_PER_SECOND;
        samples_left_over =  samples_left_over % DC_FRAMES_PER_SECOND;
	
	return samples_this_frame;
}

/* attenuation in dB */
void osd_set_mastervolume(int _attenuation)
{
	if (_attenuation > 0) _attenuation = 0;
	if (_attenuation < -32) _attenuation = -32;

	attenuation = _attenuation;
//	stream_volume(attenuation);
}

int osd_get_mastervolume(void)
{
	return attenuation;
}

void osd_sound_enable(int enable_it)
{
}

void osd_opl_control(int chip,int reg)
{
}

void osd_opl_write(int chip,int data)
{
}
/* endof sound.c */


//static uint32 txr_alloc_base;
//void ta_poly_hdr_col(poly_hdr_t *target, int translucent);
//void ta_txr_release_all();


/* Update Video */
void update_video(void) {
        int x, y, c;

        /* Width and height of viewport */
        int w = (cart.type ? 160 : 256);
        int h = (cart.type ? 144 : 192);

        /* Offset in display bitmap */
        int sx = (cart.type ? 48 : 0);
        int sy = (cart.type ? 24 : 0);

        for(y = 0; y < h; y++) {
                /* Point to current line of bitmap */
                char *p = &bitmap.data[((sy + y) * bitmap.width) + (sx)];

                for(x = 0; x < w; x++) {
                        c = (p[x] & PIXEL_MASK);

                        txrtmp[y*256+x] = RGB565(bitmap.pal.color[c][0],bitmap.pal.color[c][1],bitmap.pal.color[c][2]);
                }
        }
}

static void disc_display(polyplace_t *p) {
        vertex_ot_t     vert;
	poly_hdr_t	hdr;

        ta_poly_hdr_txr(&hdr, TA_OPAQUE, TA_RGB565, 256, 256, disc_txr, TA_NO_FILTER);
        ta_commit_poly_hdr(&hdr);

	vert.flags = TA_VERTEX_NORMAL;
        vert.x = p->x + 0.0f; vert.y = p->y + 480.0f; vert.z = p->z;
        vert.a = 1.0f; //vert.r = 0.0f; vert.g = 0.0f; vert.b = 0.0f;
        vert.r = vert.g = vert.b = 1.0f;
        vert.u = 0.0f; vert.v = ss_select; //vert.v = 1.0f;
        ta_commit_vertex(&vert, sizeof(vert));

	vert.flags = TA_VERTEX_NORMAL;
        vert.x = p->x + 0.0f; vert.y = p->y + 0.0f; vert.z = p->z;
        vert.a = 1.0f; //vert.r = 0.0f; vert.g = 0.0f; vert.b = 0.0f;
        vert.u = 0.0f; vert.v = 0.0f;
        ta_commit_vertex(&vert, sizeof(vert));

	vert.flags = TA_VERTEX_NORMAL;
        vert.x = p->x + 640.0f; vert.y = p->y + 480.0f; vert.z = p->z;
        vert.a = 1.0f; //vert.r = 0.0f; vert.g = 0.0f; vert.b = 0.0f;
        //vert.u = 1.0f; vert.v = ss_select; //vert.v = 1.0f;
        vert.u = ss_select_w; vert.v = ss_select; //vert.v = 1.0f;
        ta_commit_vertex(&vert, sizeof(vert));

	vert.flags = TA_VERTEX_EOL;
        vert.x = p->x + 640.0f; vert.y = p->y + 0.0f; vert.z = p->z;
        vert.a = 1.0f;// vert.r = vert.g = vert.b = 1.0f;//vert.r = 0.0f; vert.g = 0.0f; vert.b = 0.0f;
        //vert.u = 1.0f; vert.v = 0.0f;
        vert.u = ss_select_w; vert.v = 0.0f;
        ta_commit_vertex(&vert, sizeof(vert));
}

static void disc_blank() {
	poly_hdr_t	hdr;
        ta_poly_hdr_col(&hdr, TA_TRANSLUCENT);
        ta_commit_poly_hdr(&hdr);
}

void disclaimer() {

        ta_begin_render();
        disc_display(&polys);
        ta_commit_eol();
        disc_blank();
        ta_commit_eol();
        ta_finish_frame();

        ta_begin_render();
        disc_display(&polys);
        ta_commit_eol();
        disc_blank();
        ta_commit_eol();
        ta_finish_frame();

}


/* Show how many frames have been rendered */
void display_fcount() {
        return;
}

/* Updates the Controller's input */

int update_input() {
        cont_cond_t FirstCont;
        cont_cond_t SecondCont;

        FirstCont=getButtons(0);

        memset(&input, 0, sizeof(t_input));

        /* only  player 1 can exit, by pressing rtrig & ltrig */
        if(FirstCont.ltrig & FirstCont.rtrig)           exit_flag = 1;

        //if(FirstCont.rtrig) frame_skip=max_skip;
        //if(FirstCont.ltrig) frame_skip=min_skip;
        if((!(FirstCont.buttons & CONT_X)) && (!(FirstCont.buttons & CONT_Y))) { save_state(); return 0; }

        /* first controller */
        if(!(FirstCont.buttons  & CONT_START))          input.system |= (cart.type) ? INPUT_START : INPUT_PAUSE;
        if(!(FirstCont.buttons  & CONT_DPAD_UP))         input.pad[0] |= INPUT_UP;
        else
        if(!(FirstCont.buttons  & CONT_DPAD_DOWN))       input.pad[0] |= INPUT_DOWN;
        if(!(FirstCont.buttons  & CONT_DPAD_LEFT))       input.pad[0] |= INPUT_LEFT;
        else
        if(!(FirstCont.buttons  & CONT_DPAD_RIGHT))      input.pad[0] |= INPUT_RIGHT;
        if(!(FirstCont.buttons  & CONT_B))               input.pad[0] |= INPUT_BUTTON2;
        if(!(FirstCont.buttons  & CONT_A))               input.pad[0] |= INPUT_BUTTON1;

        /* second controller */
        SecondCont=getButtons(1);
        if(!(SecondCont.buttons & CONT_DPAD_UP))   input.pad[1] |= INPUT_UP;
        else
        if(!(SecondCont.buttons  & CONT_DPAD_DOWN))   input.pad[1] |= INPUT_DOWN;
        if(!(SecondCont.buttons  & CONT_DPAD_LEFT))   input.pad[1] |= INPUT_LEFT;
        else
        if(!(SecondCont.buttons  & CONT_DPAD_RIGHT))   input.pad[1] |= INPUT_RIGHT;
        if(!(SecondCont.buttons  & CONT_B))   input.pad[1] |= INPUT_BUTTON2;
        if(!(SecondCont.buttons  & CONT_A))   input.pad[1] |= INPUT_BUTTON1;

        return(0);
}


int getKeys () {
        int key;
        kbd_poll(mkeyb1);
        key = kbd_get_key();
        return key;
}
inline cont_cond_t getButtons (int port) {
	cont_cond_t cond;

	if (port == 0) {
                cont_get_cond (mcont1, &cond);
        } else {
                cont_get_cond (mcont2, &cond);
	}

	return cond;
}


/* SRAM routines */
void system_load_sram() {
        return;
}
void system_save_sram() {
        return;
}
void load_sram() {
        return;
}
void save_sram() {
        return;
}
/* Save States */
void load_state() {
        return;
}
void novmu();

//uint8 SaveSTATE[0x10000];

void save_state() {
        uint16 block_number;
	uint8 temp_mem[200];
	uint8 *free_mem = (uint8 *)temp_mem;
        uint8 addr = maple_first_vmu();
        uint8 *SaveSTATE;
        int statesize=0;

        if (!addr) {
                novmu();
                printf("No VMU was found\r\n");
                return;
        }

        vmu_display(saving_vmu_icon);
        thd_sleep(100);

        SaveSTATE = malloc(100000); // 100kb should be enough

        system_save_state(SaveSTATE,statesize);

        if(statesize>13000) {
                dc_print("State is over 13kb, can't save");
                free(SaveSTATE);
                return;
        }

        block_number = check_vmu_for_game(ROM.file);

        /* found the game in SaveRAM */
	if (block_number != 0) {
                uint8 temp_buf[13000];
		uint8 *vmu_file = (uint8 *)temp_buf;
                //uint8 free_blocks = check_free_blocks (free_mem);
                int i;

                dc_print("Saving Game...");

                create_vmu_header (vmu_file, ROM.file, "SMSPlus! Save State", 8576);

                for (i=640; i<1024; i++) {
			vmu_file[i] = 0;
		}

                for (i=0; i<13000; i++) {
                        vmu_file[i + 1024] = SaveSTATE[i];
		}

                do_crc(vmu_file, 13000);

                upload_data_by_block (vmu_file, (uint32)block_number, 32);

        } else {
		uint8 free_blocks = check_free_blocks (free_mem);
                uint8 temp_buf[13000];
		uint8 *vmu_file = (uint8 *)temp_buf;
                uint8 first_free_block;
                int i;

                if (free_blocks < 32) {
                        dc_print("You need 32 free blocks to Save");
                        thd_sleep(5000);
			return;
		}

                dc_print("Saving Game...");

                create_vmu_header(vmu_file, ROM.file, "SMSPlus! Save State", 13000);

                /* filler */
                for (i=640; i<1024; i++) {
			vmu_file[i] = 0;
		}

                for (i=0; i<13000; i++) {
                        vmu_file[i + 1024] = SaveSTATE[i];
		}

                do_crc (vmu_file, 13000);

                first_free_block = find_first_free_block(free_mem);

                update_fat (free_mem, 32);

                upload_vmu_data (vmu_file, free_mem, 32);

                update_vmu_dir (first_free_block, ROM.file, 32);
	}
        free(SaveSTATE);

        thd_sleep(100);
printf("BLAH BLAH\r\n");
        vmu_display(vmu_icon);
printf("BLAH BLAH\r\n");
}

#define ZIP_FILE 0
#define PLAIN_FILE 1

#include "unzip.h"

int load_rom(char *fd_fname)
{
    int size;
    //FILE *fd = (FILE *) NULL;
    int fd , zyn , dump_size;
    byte *dump_cart;
    char *ifn;

    ifn=(char *)malloc(256);
    strcpy(ifn,fd_fname);
    if(strcmp(&ifn[strlen(ifn)-3],"zip")==0) {
        printf("sms_debug: zip file\r\n");
        zyn = ZIP_FILE;
        cart.zip = 1;
    } else {
        printf("sms_debug: plain file\r\n");
        zyn = PLAIN_FILE;
        cart.zip = 0;
    }

    if(ROM.file) {
        free(ROM.file);
    }
    ROM.file=malloc(1024);

    if (zyn == ZIP_FILE) {
        f = (FakeFileHandle *) malloc (sizeof (FakeFileHandle));
        if( !f ) {
            printf("load_rom: failed to malloc FakeFileHandle\r\n");
            free(ifn);
            return 0;
        }
        memset (f, 0, sizeof (FakeFileHandle));
        f->filename=malloc(1024);
        if (!f->filename) {
                printf("load_rom: failed to malloc f->filename\r\n");
                free(f); free(ifn);
                return 0;
        }
        if(load_zipped_file(ifn,"BUBBLE~1.SMS",&f->data,&f->length,f->filename)==0)
        {
//          printf("found in zipped file!\r\n");
          f->type=kZippedFile;
          cart.crc=crc32 (0L, f->data, f->length);
          strcpy(ROM.file,f->filename);
          ROM.size=f->length;
          //cart.crc = f->crc;
          //printf("crc: %08lx\r\n",cart.crc);

          cart.pages = (f->length / 0x4000);
          cart.rom = malloc(f->length);
          if (!cart.rom) { printf("cart.rom malloc error #02\r\n"); free(ifn); return 0; }
          cart.type = 0;
          ss_select = ss_mastersystem;
          ss_select_w = ss_mastersystem_w;
          frame_skip = max_skip;
          memcpy(cart.rom, f->data, f->length);
          if((strcmp(&f->filename[strlen(f->filename)-2],"GG")==0) || (strcmp(&f->filename[strlen(f->filename)-2],"gg")==0)) {
                cart.type = 1;
                ss_select = ss_gamegear;
                ss_select_w = ss_gamegear_w;
                frame_skip = min_skip;
          } else {
                printf("master system rom detected\r\n");
          }
          return 1;
        } else {
          free(f);
          return 0;
        }

    }

#ifdef _MP3_SUPPORT_
        if(strcmp(&ifn[strlen(ifn)-3],"mp3")==0) {
                char *argv[] = {
                        "/cd/austin~1.mp3",
                        "/cd/austin~1.mp3"
		};
                prcs_load_and_exec("/rd/mp3play.klf",2,argv);
                free(ifn);
                return 3;
        }
#endif

    fd = fs_open(ifn, O_RDONLY);
    if (fd == 0) {
      fs_close(fd);
      display_dcp(splash);
      dc_print("The ROM you selected was not found on this CD.");
      thd_sleep(100);
      free(ifn);
      return 0;
    }

    fs_seek(fd, 0, SEEK_END);
    size = fs_tell(fd);
    fs_seek(fd, 0, SEEK_SET);

    /*if(size < 32000) {
      fclose(fd);
      free(ifn);
      display_dcp(splash);
      screenprintf(100,"The ROM you selected is INVALID, it must be",1);
      screenprintf(125,"larger than 32k... can not continue.",1);
      thd_sleep(5000);
      return 0;
    }*/

    if((size / 512) & 1) {
        size -= 512;
        fs_seek(fd, 512, SEEK_SET);
    }

    cart.pages = (size / 0x4000);
    cart.rom = malloc(size);
    if(!cart.rom) { printf("cart.rom malloc error #03\r\n"); free(cart.rom); free(ifn); return 0; }
    fs_read(fd, cart.rom, size);
    fs_close(fd);

    strcpy(ROM.file,ifn);
    ROM.size=size;

    dump_cart = malloc(size);
    thd_sleep(10);
    dump_size = size;
    memcpy(dump_cart,cart.rom,dump_size);
    cart.crc = crc32(0, dump_cart, dump_size);

    thd_sleep(10);
    free(dump_cart);

    cart.type = 0;
    ss_select = ss_mastersystem;
    ss_select_w = ss_mastersystem_w;
    frame_skip = max_skip;
    if((strcmp(&ifn[strlen(ifn)-2],"gg")==0) || (strcmp(&ifn[strlen(ifn)-2],"GG")==0)) {
        cart.type = 1;
        ss_select = ss_gamegear;
        ss_select_w = ss_gamegear_w;
        frame_skip = min_skip;
    }

    free(ifn);

    return 1;
}

int screenprintf(int xpos, char *text, int type) {
    if (type == 0) {
       bfont_draw_str(vram_s+xpos*SCREEN_W+20, SCREEN_W, 1, text);
    } else {
       bfont_draw_twriter(vram_s+xpos*SCREEN_W+20, SCREEN_W, text);
    }
    return(0);
}

void bfont_draw_twriter(uint16 *buffer, int bufwidth, char *str) {
    while (*str) {
        bfont_draw(buffer += 12, bufwidth, 1, *str++);
        thd_sleep(100); /* sleep for 100 ms */
    }
}

void putpixel(int x, int y, int r, int g, int b) {
        vram_s[y*SCREEN_W+x] = RGB565(r,g,b);
}

void clearscr(int xres, int yres) {
    int x, y;
    for(x=0; x<xres; x++)
            for(y=0; y<yres; y++)
                    txrtmp[xres*y + x] = RGB565(0,0,0);
    for(x=0; x<xres; x++)
            for(y=0; y<yres; y++)
                    guitxrtmp[xres*y + x] = RGB565(0,0,0);
    return;
}

void fb_rect(int x, int y, int w, int h, int r, int g, int b)
{
    for(; x < w; x++)
            for(; y < h; y++)
                    vram_s[w*y + x] = RGB565(r,g,b);
}

/* Draws an entire string using the loaded font. */
void sdraw_string(int x1, int y1, unsigned short color, char *str) {
	while (*str) {
                sdraw_char(x1, y1, color, *str);
		x1 += 8; str++;
	}
}

/* Draws a single character using the loaded font. Assumes a
   PM_RGB565 display mode. The original only supported 640x480
   mode. This now supports the current resolution. */
void sdraw_char(int x1, int y1, unsigned short color, int ch) {
        int offs = ch * ffont_height;
        unsigned short * out = vram_s + y1 * SCREEN_W + x1;
	int x, y;
	
        for (y=0; y<ffont_height; y++) {
		int mask = 0x80;
		for (x=0; x<8; x++) {
			unsigned short pixel = 0;
                        if (ffont_bm[offs] & mask) {
				pixel = color;
				out[x] = pixel;
			}

			mask >>= 1;
		}
                out += SCREEN_W; offs++;
	}
}

/* You must call this function to setup a font to use for
   the rest of the drawing functions. The font should be composed
   of 256 bitmapped 8-pixel-wide rows (1 byte per row). */
void sfont_set(unsigned char * fbm, int fh) {
        ffont_height = fh;
        ffont_bm = fbm;
}


/* KF 05-31-2001 added snd_memset routine from kos-0.90 */
/*void snd_memset(uint32 toi, unsigned long what, int length) {
	uint32 *to = (uint32 *)(0xa0800000 + toi);
	int i;
	
	if (length % 4)
		length = (length/4)+1;
	else
		length = length/4;
	
	for (i=0; i<length; i++) {
		*to++ = what;
		if (i && !(i % 8)) snd_ram_write_wait();
	}

}*/

/* store queue stuff, thanks joey and regex */
void doPrestore(uint32 addr)
{
	asm("pref @r4");
}

/* store queues */
void sqmemcpy(void *dest, void *src)
{
	int i,j;
	volatile unsigned long *regs = (unsigned long *)0xff000038;
	unsigned long formattedAddr;
	uint32 *pSQ;

	regs[0] = regs[1] = ((unsigned long)dest >> 24);
	pSQ = ((uint32*) 0xe0000000);
  
	formattedAddr = 0xe0000000 | (((unsigned long)dest) &= 0x03FFFFFF);
  
	for (i = 0; i < 13; i++)
	{
		if ((i % 2) == 0)
		{			/* SQ0 */
			for (j = 0; j < 8; j++)
			{
				pSQ[j] = ((uint32 *)src)[(i*8) + j];
			}
			doPrestore(formattedAddr);
		}
		else
		{			/* SQ1 */
			for (j = 0; j < 8; j++)
			{
				pSQ[j + 8] = ((uint32 *)src)[(i*8) + j];
			}
			doPrestore(formattedAddr);
		}
		formattedAddr += 32;
	}
}


/****************************************************/
/******************** MISCFUNC.C ********************/
/******************** MISCFUNC.C ********************/
/****************************************************/
/*
FILE * fopen(const char *path, const char *mode)
{
    if (mode[0] == 'r')
        return (FILE *)fs_open(path, O_RDONLY);
    if (mode[0] == 'w')
        return (FILE *)fs_open(path, O_WRONLY);
}
int fclose(FILE *stream)
{
    fs_close((unsigned int)stream);
    return 0;
}

unsigned int fread(void *ptr, unsigned int size, unsigned int nmemb, FILE *stream)
{
    return fs_read((unsigned int)stream, ptr, size*nmemb)/size;
}

unsigned int ftell (FILE *stream) {
    return fs_tell((unsigned int)stream);
}

unsigned int fwrite(void *ptr, unsigned int size, unsigned int nmemb, FILE *stream) {
    //return fs_write((unsigned int)stream, ptr, size*nmemb)/size;
}

int fseek(FILE *stream, long offset, int whence)
{
    return fs_seek((unsigned int)stream, offset, whence);
}*/

void exittomenu()
{
	(*(void(**)())0x8c0000e0)(1);
}

/****************************************************/
/******************** DCPIMAGE.C ********************/
/******************** DCPIMAGE.C ********************/
/****************************************************/

#include "dcp/dcp_image.h"

#define dcp565(r, g, b) ((r >> 3) << 11) | ((g >> 2) << 5) | ((b >> 3) << 0);

struct dbp_hdr 
{
	char   version[2];        /* version code of DBP file, currently 1A */
	char   creationdate[8];   /* filecreationdate (format mmddyyyy)     */
	char   creator[48];       /* copyright notification                 */
	char   xmax1;             /* byte 1 of width of picture             */
	char   xmax2;             /* byte 2 of width of picture             */
	char   xmax3;             /* byte 3 of width of picture             */
	char   ymax1;             /* byte 1 of height of picture            */
	char   ymax2;             /* byte 2 of height of picture            */
	char   ymax3;             /* byte 3 of height of picture            */
};

int shift_add(char c, int r)
{
  int result = r;
  result *= 10;
  result += (int)c - (int)'0';
  return result;
}

int _dcp_load(uint8 * _dcp_file, uint8 *_pic_buffer, int _compression)
{
        int z;

        if (_compression==1) {
                z=rnc_unpack(_pic_buffer,_dcp_file);
        }

        return(0);
}

int dcp_load(uint8 * dcp_file, uint8 *pic_buffer) {
        return(_dcp_load(dcp_file,pic_buffer,1));
}

int dbp_load(uint8 * dcp_file, uint8 *pic_buffer) {
        return(_dcp_load(dcp_file,pic_buffer,0));
}

int display_dbp(uint8 *_pic_buffer) {
        return(display_dcp(_pic_buffer));
}

int display_dcp(uint8 *__pic_buffer) {
	int x;
	int y;
	int r;
	int g;
	int b;
	int xmax;
	int ymax;
        int xpos=0;
        int ypos=0;
	struct dbp_hdr dbphdr;

    poly_hdr_t poly;

        draw_background();

return 0;

    ta_poly_hdr_col(&poly, TA_TRANSLUCENT);

    ta_begin_render();


    ta_commit_eol();

    ta_commit_poly_hdr(&poly);

    ta_commit_eol();

    ta_finish_frame();
        return 0;


        //memcpy(&dbphdr, __pic_buffer, sizeof(dbphdr)); __pic_buffer += sizeof(dbphdr);
	xmax=0;
	ymax=0;
	xmax = shift_add(dbphdr.xmax1,0);
	xmax = shift_add(dbphdr.xmax2,xmax);
	xmax = shift_add(dbphdr.xmax3,xmax);
	ymax = shift_add(dbphdr.ymax1,0);
	ymax = shift_add(dbphdr.ymax2,ymax);
	ymax = shift_add(dbphdr.ymax3,ymax);

        xmax = 640;
        ymax = 480;
        //xmax=512;
        //ymax=512;

        //--- display picture on specified location ---
	y = 0;
	while (y !=ymax) 
		{
		x = 0;
		y++;
		while (x !=xmax) 
			{
			x++;
                        r = *__pic_buffer++;
                        g = *__pic_buffer++;
                        b = *__pic_buffer++;
                        if ((x!=1) && (x!=xmax) && (y!=1) && (y!=ymax)) {
                                 guitxrtmp[(x+xpos) + (640*(y+ypos))] = dcp565(r,g,b);
				 }
			}
		}
        ta_begin_render();
        gui_txr_display(1.0f, &polys);
        ta_commit_eol();
        disc_blank();
        ta_commit_eol();
        ta_finish_frame();

        return(0);
}


void draw_background() {
	vertex_ot_t	v;
	poly_hdr_t	hdr;

        ta_poly_hdr_txr(&hdr, TA_OPAQUE, TA_RGB565, 1024, 512, bkg_tex, TA_NO_FILTER);
	ta_commit_poly_hdr(&hdr);

	/* - -
	   + - */
	v.flags = TA_VERTEX_NORMAL;
        v.x = 0.0f;
        v.y = 512.0f;
	v.z = 1.0f;
        v.u = 0.0f; v.v = 1.0f;
        v.a = 1.0f; v.r = v.g = v.b = 1.0f;
	v.oa = v.or = v.og = v.ob = 0.0f;
	ta_commit_vertex(&v, sizeof(v));

	/* + -
	   - - */
	v.y = 0.0f;
	v.v = 0.0f;
	ta_commit_vertex(&v, sizeof(v));

	/* - -
	   - + */
        v.x = 1024.0f;
        v.y = 512.0f;
        v.u = 1.0f; v.v = 1.0f;
	ta_commit_vertex(&v, sizeof(v));

	/* - +
	   - - */
	v.flags = TA_VERTEX_EOL;
        v.y = 0.0f; v.v = 0.0f;
	ta_commit_vertex(&v, sizeof(v));

}

/* myf0nt.c */
unsigned int font_tex;
void font_init(void)
{
    unsigned char font[4096];
    int i,x,y,c;
    unsigned int fd;
    unsigned short *tex;

    fd = fs_open("/rd/8x16.bin", O_RDONLY);
    fs_read(fd, font, 4096);
    fs_close(fd);

    font_tex = ta_txr_allocate(256*128*2);
    tex = ta_txr_map(font_tex);
    
    c = 0;
    for(y = 0; y < 128 ; y+=16)
        for(x = 0; x < 256 ; x+=8) {
            for(i = 0; i < 16; i++) {
                tex[x + (y+i) * 512 + 0] = 0xffff * ((font[c+i] & 0x80)>>7);
                tex[x + (y+i) * 512 + 1] = 0xffff * ((font[c+i] & 0x40)>>6);
                tex[x + (y+i) * 512 + 2] = 0xffff * ((font[c+i] & 0x20)>>5);
                tex[x + (y+i) * 512 + 3] = 0xffff * ((font[c+i] & 0x10)>>4);
                tex[x + (y+i) * 512 + 4] = 0xffff * ((font[c+i] & 0x08)>>3);
                tex[x + (y+i) * 512 + 5] = 0xffff * ((font[c+i] & 0x04)>>2);
                tex[x + (y+i) * 512 + 6] = 0xffff * ((font[c+i] & 0x02)>>1);
                tex[x + (y+i) * 512 + 7] = 0xffff * (font[c+i] & 0x01);
            }
            c+=16;
        }
}

void draw_color_rect(int x, int y, int w, int h, float a, float r, float g, float b, float z, int trans)
{
    vertex_oc_t vert;
    poly_hdr_t poly;

    if (!trans)
        ta_poly_hdr_col(&poly, TA_OPAQUE);
    else
        ta_poly_hdr_col(&poly, TA_TRANSLUCENT);
    ta_commit_poly_hdr(&poly);

    vert.flags = TA_VERTEX_NORMAL;
    vert.x = x;
    vert.y = y+h-1;
    vert.z = z;
    vert.a = a;
    vert.r = r;
    vert.g = g;
    vert.b = b;
    ta_commit_vertex(&vert, sizeof(vert));

    vert.y = y;
    ta_commit_vertex(&vert, sizeof(vert));

    vert.x = x+w-1;
    vert.y = y+h-1;
    ta_commit_vertex(&vert, sizeof(vert));
	
    vert.flags = TA_VERTEX_EOL;
    vert.y = y;
    ta_commit_vertex(&vert, sizeof(vert));
}

void draw_char(float x1, float y1, float z1, float a, float r, float g, float b, int c, float xs, float ys) {
    vertex_ot_t     vert;
    int             ix, iy;
    float           u1, v1, u2, v2;
    
    ix = (c % 32) * 8;
    iy = (c / 32) * 16;
    u1 = (float)(ix) / 512.0f;
    v1 = (float)(iy) / 512.0f;
    u2 = (ix+8.0f) / 512.0f;
    v2 = (iy+16.0f) / 512.0f;
    
    vert.flags = TA_VERTEX_NORMAL;
    vert.x = x1;
    vert.y = y1 + 16.0f * ys;
    vert.z = z1;
    vert.u = u1;
    vert.v = v2;
    vert.dummy1 = vert.dummy2 = 0;
    vert.a = a;
    vert.r = r;
    vert.g = g;
    vert.b = b;
    vert.oa = vert.or = vert.og = vert.ob = 0.0f;
    ta_commit_vertex(&vert, sizeof(vert));
    
    vert.x = x1;
    vert.y = y1;
    vert.u = u1;
    vert.v = v1;
    ta_commit_vertex(&vert, sizeof(vert));
    
    vert.x = x1 + 8.0f * xs;
    vert.y = y1 + 16.0f * ys;
    vert.u = u2;
    vert.v = v2;
    ta_commit_vertex(&vert, sizeof(vert));
    
    vert.flags = TA_VERTEX_EOL;
    vert.x = x1 + 8.0f * xs;
    vert.y = y1;
    vert.u = u2;
    vert.v = v1;
    ta_commit_vertex(&vert, sizeof(vert));
}

void draw_string(float x, float y, float z, float a, float r, float g, float b, char *str, float xs, float ys) {
  poly_hdr_t poly;
  //ta_poly_hdr_txr(&poly, TA_TRANSLUCENT, TA_ARGB1555, 512, 512, font_tex, TA_BILINEAR_FILTER);
  ta_poly_hdr_txr(&poly, TA_TRANSLUCENT, TA_RGB565, 512, 512, font_tex, TA_BILINEAR_FILTER);
  //ta_poly_hdr_txr(&poly, TA_TRANSLUCENT, TA_ARGB1555, 256, 256, font_tex, TA_BILINEAR_FILTER);
  ta_commit_poly_hdr(&poly);
  
  while (*str) {
    draw_char(x, y, z, a, r, g, b, *str++, xs, ys);
        x+=8*xs;
  }
}

void draw_string_center(float y, float z, float a, float r, float g, float b, char *str, float xs, float ys)
{
    draw_string((640.0f - strlen(str)*8*xs)/2, y, z, a, r, g, b, str, xs, ys);
}

/* void pal();
 *
 *   some very good code thanks to PAL-enforcer
 *
 */

void pal() {
	register uint32 val = *(uint32 *)0xa05f80d8;
	register uint32 val2 = (val>>16) & 0x03ff;

	/* acknowledge break */
	*(uint32 *)0xff200020 |= (1<<14) | (1<<15);

	if ((val2 > 500) && (val2 < 550))  {
		/* NTSC, interlace */
		val = (624<<16) | 863;	/* set PAL, interlace */
        } else if ((val2 > 210) && (val2 < 300)) {
		/* NTSC, non-interlace */
		val = (312<<16) | 863;	/* set PAL, non-interlace */
	} else {
		goto alldone;
	}

	*(uint32 *)0xff200008 = 0;
	__asm__("nop");
	__asm__("nop");
	__asm__("nop");
	__asm__("nop");
	__asm__("nop");
	__asm__("nop");
	__asm__("nop");
	__asm__("nop");
	__asm__("nop");
	__asm__("nop");
	__asm__("nop");
	*(uint32 *)0xa05f80d8 = val;
	*(uint32 *)0xff200008 = (2<<4) | (2<<2);

alldone:
	__asm__("rte");
	__asm__("nop");
        return;
}

/********************* OSD.C *********************/

int osd_fseek(FILE *stream, long offset, int whence)
{
  fs_seek((unsigned int)stream, offset, whence);
  return 0;
}
long osd_ftell(FILE *stream)
{
  return fs_tell((unsigned int)stream);
}

/********************* UNZIP.C ************************/
#include <stdio.h>
//#include <stdlib.h>
#include "shared.h"
#include "unzip.h"
//#include "mame.h"

//#include <string.h>
//#include <ctype.h>
//#include <assert.h>
#include "zlib.h"

#ifndef toupper
#define toupper(c)  ( (c)-'a'+'A' )
#endif

/* public globals */
int	gUnzipQuiet = 0;		/* flag controls error messages */


#define ERROR_CORRUPT "The zipfile seems to be corrupt, please check it"
#define ERROR_FILESYSTEM "Your filesystem seems to be corrupt, please check it"
#define ERROR_UNSUPPORTED "The format of this zipfile is not supported, please recompress it"

#define INFLATE_INPUT_BUFFER_MAX 16384
#ifndef MIN
#define MIN(x,y) ((x)<(y)?(x):(y))
#endif


void logerror (char *fmt, ...) {
	va_list		args;
	char		pbuf[2048];
	va_start(args, fmt);
	vsprintf(pbuf, fmt, args);
	va_end(args);
        printf(pbuf);
        return;
}

/* Print a error message */
void errormsg(const char* extmsg, const char* usermsg, const char* zipname) {
	/* Output to the user with no internal detail */
	if (!gUnzipQuiet)
		printf("Error in zipfile %s\n%s\n", zipname, usermsg);
	/* Output to log file with all informations */
        logerror("Error in zipfile %s: %s\n", zipname, extmsg);
}

/* -------------------------------------------------------------------------
   Unzip support
 ------------------------------------------------------------------------- */

/* Use these to avoid structure padding and byte-ordering problems */
static UINT16 read_word (char *buf) {
   unsigned char *ubuf = (unsigned char *) buf;

   return ((UINT16)ubuf[1] << 8) | (UINT16)ubuf[0];
}

/* Use these to avoid structure padding and byte-ordering problems */
static UINT32 read_dword (char *buf) {
   unsigned char *ubuf = (unsigned char *) buf;

   return ((UINT32)ubuf[3] << 24) | ((UINT32)ubuf[2] << 16) | ((UINT32)ubuf[1] << 8) | (UINT32)ubuf[0];
}

/* Locate end-of-central-dir sig in buffer and return offset
   out:
	*offset offset of cent dir start in buffer
   return:
	==0 not found
	!=0 found, *offset valid
*/
static int ecd_find_sig (char *buffer, int buflen, int *offset)
{
	static char ecdsig[] = { 'P', 'K', 0x05, 0x06 };
	int i;
	for (i=buflen-22; i>=0; i--) {
		if (memcmp(buffer+i, ecdsig, 4) == 0) {
			*offset = i;
			return 1;
		}
	}
	return 0;
}

/* Read ecd data in zip structure
   in:
     zip->fp, zip->length zip file
   out:
     zip->ecd, zip->ecd_length ecd data
*/
static int ecd_read(ZIP* zip) {
	char* buf;
	int buf_length = 1024; /* initial buffer length */

	while (1) {
		int offset;

		if (buf_length > zip->length)
			buf_length = zip->length;

                if (osd_fseek(zip->fp, zip->length - buf_length, SEEK_SET) != 0) {
			return -1;
		}

		/* allocate buffer */
		buf = (char*)malloc( buf_length );
		if (!buf) {
			return -1;
		}

		if (fread( buf, buf_length, 1, zip->fp ) != 1) {
			free(buf);
			return -1;
		}

		if (ecd_find_sig(buf, buf_length, &offset)) {
			zip->ecd_length = buf_length - offset;

			zip->ecd = (char*)malloc( zip->ecd_length );
			if (!zip->ecd) {
				free(buf);
				return -1;
			}

			memcpy(zip->ecd, buf + offset, zip->ecd_length);

			free(buf);
			return 0;
		}

		free(buf);

		if (buf_length < zip->length) {
			/* double buffer */
			buf_length = 2*buf_length;

			logerror("Retry reading of zip ecd for %d bytes\n",buf_length);

		} else {
			return -1;
		}
	}
}

/* offsets in end of central directory structure */
#define ZIPESIG		0x00
#define ZIPEDSK		0x04
#define ZIPECEN		0x06
#define ZIPENUM		0x08
#define ZIPECENN	0x0a
#define ZIPECSZ		0x0c
#define ZIPEOFST	0x10
#define ZIPECOML	0x14
#define ZIPECOM		0x16

/* offsets in central directory entry structure */
#define ZIPCENSIG	0x0
#define ZIPCVER		0x4
#define ZIPCOS		0x5
#define	ZIPCVXT		0x6
#define	ZIPCEXOS	0x7
#define ZIPCFLG		0x8
#define ZIPCMTHD	0xa
#define ZIPCTIM		0xc
#define ZIPCDAT		0xe
#define ZIPCCRC		0x10
#define ZIPCSIZ		0x14
#define ZIPCUNC		0x18
#define ZIPCFNL		0x1c
#define ZIPCXTL		0x1e
#define ZIPCCML		0x20
#define ZIPDSK		0x22
#define ZIPINT		0x24
#define ZIPEXT		0x26
#define ZIPOFST		0x2a
#define ZIPCFN		0x2e

/* offsets in local file header structure */
#define ZIPLOCSIG	0x00
#define ZIPVER		0x04
#define ZIPGENFLG	0x06
#define ZIPMTHD		0x08
#define ZIPTIME		0x0a
#define ZIPDATE		0x0c
#define ZIPCRC		0x0e
#define ZIPSIZE		0x12
#define ZIPUNCMP	0x16
#define ZIPFNLN		0x1a
#define ZIPXTRALN	0x1c
#define ZIPNAME		0x1e

/* Opens a zip stream for reading
   return:
     !=0 success, zip stream
     ==0 error
*/
ZIP* openzip(const char* zipfile) {
	/* allocate */
	ZIP* zip = (ZIP*)malloc( sizeof(ZIP) );
	if (!zip) {
		return 0;
	}

	/* open */
        zip->fp = fopen(zipfile, "rb");
	if (!zip->fp) {
		errormsg ("Opening for reading", ERROR_FILESYSTEM, zipfile);
		free(zip);
		return 0;
	}

	/* go to end */
        //if (fseek(zip->fp, 0L, SEEK_END) != 0) {
        if (osd_fseek(zip->fp, 0L, SEEK_END) != 0) {
		errormsg ("Seeking to end", ERROR_FILESYSTEM, zipfile);
		fclose(zip->fp);
		free(zip);
		return 0;
	}

	/* get length */
        zip->length = osd_ftell(zip->fp);
	if (zip->length < 0) {
		errormsg ("Get file size", ERROR_FILESYSTEM, zipfile);
		fclose(zip->fp);
		free(zip);
		return 0;
	}
	if (zip->length == 0) {
		errormsg ("Empty file", ERROR_CORRUPT, zipfile);
		fclose(zip->fp);
		free(zip);
		return 0;
	}

	/* read ecd data */
	if (ecd_read(zip)!=0) {
		errormsg ("Reading ECD (end of central directory)", ERROR_CORRUPT, zipfile);
		fclose(zip->fp);
		free(zip);
		return 0;
	}

	/* compile ecd info */
	zip->end_of_cent_dir_sig = read_dword (zip->ecd+ZIPESIG);
	zip->number_of_this_disk = read_word (zip->ecd+ZIPEDSK);
	zip->number_of_disk_start_cent_dir = read_word (zip->ecd+ZIPECEN);
	zip->total_entries_cent_dir_this_disk = read_word (zip->ecd+ZIPENUM);
	zip->total_entries_cent_dir = read_word (zip->ecd+ZIPECENN);
	zip->size_of_cent_dir = read_dword (zip->ecd+ZIPECSZ);
	zip->offset_to_start_of_cent_dir = read_dword (zip->ecd+ZIPEOFST);
	zip->zipfile_comment_length = read_word (zip->ecd+ZIPECOML);
	zip->zipfile_comment = zip->ecd+ZIPECOM;

	/* verify that we can work with this zipfile (no disk spanning allowed) */
	if ((zip->number_of_this_disk != zip->number_of_disk_start_cent_dir) ||
		(zip->total_entries_cent_dir_this_disk != zip->total_entries_cent_dir) ||
		(zip->total_entries_cent_dir < 1)) {
		errormsg("Cannot span disks", ERROR_UNSUPPORTED, zipfile);
		free(zip->ecd);
		fclose(zip->fp);
		free(zip);
		return 0;
	}

        if (osd_fseek(zip->fp, zip->offset_to_start_of_cent_dir, SEEK_SET)!=0) {
		errormsg ("Seeking to central directory", ERROR_CORRUPT, zipfile);
		free(zip->ecd);
		fclose(zip->fp);
		free(zip);
		return 0;
	}

	/* read from start of central directory */
	zip->cd = (char*)malloc( zip->size_of_cent_dir );
	if (!zip->cd) {
		free(zip->ecd);
		fclose(zip->fp);
		free(zip);
		return 0;
	}

	if (fread(zip->cd, zip->size_of_cent_dir, 1, zip->fp)!=1) {
		errormsg ("Reading central directory", ERROR_CORRUPT, zipfile);
		free(zip->cd);
		free(zip->ecd);
		fclose(zip->fp);
		free(zip);
		return 0;
	}

	/* reset ent */
	zip->ent.name = 0;

	/* rewind */
	zip->cd_pos = 0;

	/* file name */
	zip->zip = (char*)malloc(strlen(zipfile)+1);
	if (!zip->zip) {
		free(zip->cd);
		free(zip->ecd);
		fclose(zip->fp);
		free(zip);
		return 0;
	}
	strcpy(zip->zip, zipfile);

	return zip;
}

/* Reads the current entry from a zip stream
   in:
     zip opened zip
   return:
     !=0 success
     ==0 error
*/
struct zipent* readzip(ZIP* zip) {

	/* end of directory */
	if (zip->cd_pos >= zip->size_of_cent_dir)
		return 0;

	/* compile zipent info */
	zip->ent.cent_file_header_sig = read_dword (zip->cd+zip->cd_pos+ZIPCENSIG);
	zip->ent.version_made_by = *(zip->cd+zip->cd_pos+ZIPCVER);
	zip->ent.host_os = *(zip->cd+zip->cd_pos+ZIPCOS);
	zip->ent.version_needed_to_extract = *(zip->cd+zip->cd_pos+ZIPCVXT);
	zip->ent.os_needed_to_extract = *(zip->cd+zip->cd_pos+ZIPCEXOS);
	zip->ent.general_purpose_bit_flag = read_word (zip->cd+zip->cd_pos+ZIPCFLG);
	zip->ent.compression_method = read_word (zip->cd+zip->cd_pos+ZIPCMTHD);
	zip->ent.last_mod_file_time = read_word (zip->cd+zip->cd_pos+ZIPCTIM);
	zip->ent.last_mod_file_date = read_word (zip->cd+zip->cd_pos+ZIPCDAT);
	zip->ent.crc32 = read_dword (zip->cd+zip->cd_pos+ZIPCCRC);
	zip->ent.compressed_size = read_dword (zip->cd+zip->cd_pos+ZIPCSIZ);
	zip->ent.uncompressed_size = read_dword (zip->cd+zip->cd_pos+ZIPCUNC);
	zip->ent.filename_length = read_word (zip->cd+zip->cd_pos+ZIPCFNL);
	zip->ent.extra_field_length = read_word (zip->cd+zip->cd_pos+ZIPCXTL);
	zip->ent.file_comment_length = read_word (zip->cd+zip->cd_pos+ZIPCCML);
	zip->ent.disk_number_start = read_word (zip->cd+zip->cd_pos+ZIPDSK);
	zip->ent.internal_file_attrib = read_word (zip->cd+zip->cd_pos+ZIPINT);
	zip->ent.external_file_attrib = read_dword (zip->cd+zip->cd_pos+ZIPEXT);
	zip->ent.offset_lcl_hdr_frm_frst_disk = read_dword (zip->cd+zip->cd_pos+ZIPOFST);

    /* check to see if filename length is illegally long (past the size of this directory
       entry) */
    if (zip->cd_pos + ZIPCFN + zip->ent.filename_length > zip->size_of_cent_dir)
    {
        errormsg("Invalid filename length in directory", ERROR_CORRUPT,zip->zip);
        return 0;
    }

	/* copy filename */
	free(zip->ent.name);
	zip->ent.name = (char*)malloc(zip->ent.filename_length + 1);
	memcpy(zip->ent.name, zip->cd+zip->cd_pos+ZIPCFN, zip->ent.filename_length);
	zip->ent.name[zip->ent.filename_length] = 0;

	/* skip to next entry in central dir */
	zip->cd_pos += ZIPCFN + zip->ent.filename_length + zip->ent.extra_field_length + zip->ent.file_comment_length;

	return &zip->ent;
}

/* Closes a zip stream */
void closezip(ZIP* zip) {
	/* release all */
	free(zip->ent.name);
	free(zip->cd);
	free(zip->ecd);
	/* only if not suspended */
	if (zip->fp)
		fclose(zip->fp);
	free(zip->zip);
	free(zip);
}

/* Suspend access to a zip file (release file handler)
   in:
      zip opened zip
   note:
     A suspended zip is automatically reopened at first call of
     readuncompressd() or readcompressed() functions
*/
void suspendzip(ZIP* zip) {
	if (zip->fp) {
		fclose(zip->fp);
		zip->fp = 0;
	}
}

/* Revive a suspended zip file (reopen file handler)
   in:
     zip suspended zip
   return:
	zip success
	==0 error (zip must be closed with closezip)
*/
static ZIP* revivezip(ZIP* zip) {
	if (!zip->fp) {
		zip->fp = fopen(zip->zip, "rb");
		if (!zip->fp) {
			return 0;
		}
	}
	return zip;

}

/* Reset a zip stream to the first entry
   in:
     zip opened zip
   note:
     ZIP file must be opened and not suspended
*/
void rewindzip(ZIP* zip) {
	zip->cd_pos = 0;
}

/* Seek zip->fp to compressed data
   return:
	==0 success
	<0 error
*/
int seekcompresszip(ZIP* zip, struct zipent* ent) {
	char buf[ZIPNAME];
	long offset;

	if (!zip->fp) {
		if (!revivezip(zip))
			return -1;
	}

        if (osd_fseek(zip->fp, ent->offset_lcl_hdr_frm_frst_disk, SEEK_SET)!=0) {
		errormsg ("Seeking to header", ERROR_CORRUPT, zip->zip);
		return -1;
	}

	if (fread(buf, ZIPNAME, 1, zip->fp)!=1) {
		errormsg ("Reading header", ERROR_CORRUPT, zip->zip);
		return -1;
	}

	{
		UINT16 filename_length = read_word (buf+ZIPFNLN);
		UINT16 extra_field_length = read_word (buf+ZIPXTRALN);

		/* calculate offset to data and fseek() there */
		offset = ent->offset_lcl_hdr_frm_frst_disk + ZIPNAME + filename_length + extra_field_length;

                if (osd_fseek(zip->fp, offset, SEEK_SET) != 0) {
			errormsg ("Seeking to compressed data", ERROR_CORRUPT, zip->zip);
			return -1;
		}

	}

	return 0;
}

/* Inflate a file
   in:
   in_file stream to inflate
   in_size size of the compressed data to read
   out_size size of decompressed data
   out:
   out_data buffer for decompressed data
   return:
   ==0 ok

   990525 rewritten for use with zlib MLR
*/
static int inflate_file(FILE* in_file, unsigned in_size, unsigned char* out_data, unsigned out_size)
{
    int err;
	unsigned char* in_buffer;
    z_stream d_stream; /* decompression stream */

    d_stream.zalloc = 0;
    d_stream.zfree = 0;
    d_stream.opaque = 0;

	d_stream.next_in  = 0;
	d_stream.avail_in = 0;
    d_stream.next_out = out_data;
    d_stream.avail_out = out_size;

    err = inflateInit2(&d_stream, -MAX_WBITS);
	/* windowBits is passed < 0 to tell that there is no zlib header.
	 * Note that in this case inflate *requires* an extra "dummy" byte
	 * after the compressed stream in order to complete decompression and
	 * return Z_STREAM_END.
	 */
    if (err != Z_OK)
	{
		logerror("inflateInit error: %d\n", err);
        return -1;
	}

	in_buffer = (unsigned char*)malloc(INFLATE_INPUT_BUFFER_MAX+1);
	if (!in_buffer)
		return -1;

    for (;;)
	{
		if (in_size <= 0)
		{
			logerror("inflate error: compressed size too small\n");
			free (in_buffer);
			return -1;
		}
		d_stream.next_in  = in_buffer;
		d_stream.avail_in = fread (in_buffer, 1, MIN(in_size, INFLATE_INPUT_BUFFER_MAX), in_file);
		in_size -= d_stream.avail_in;
		if (in_size == 0)
			d_stream.avail_in++; /* add dummy byte at end of compressed data */

        err = inflate(&d_stream, Z_NO_FLUSH);
        if (err == Z_STREAM_END)
			break;
		if (err != Z_OK)
		{
			logerror("inflate error: %d\n", err);
			free (in_buffer);
			return -1;
		}
    }

    err = inflateEnd(&d_stream);
	if (err != Z_OK)
	{
		logerror("inflateEnd error: %d\n", err);
		free (in_buffer);
		return -1;
	}

	free (in_buffer);

	if ((d_stream.avail_out > 0) || (in_size > 0))
	{
		logerror("zip size mismatch. %i\n", in_size);
		return -1;
	}

	return 0;
}

/* Read compressed data
   out:
	data compressed data read
   return:
	==0 success
	<0 error
*/
int readcompresszip(ZIP* zip, struct zipent* ent, char* data) {
	int err = seekcompresszip(zip,ent);
	if (err!=0)
		return err;

	if (fread(data, ent->compressed_size, 1, zip->fp)!=1) {
		errormsg ("Reading compressed data", ERROR_CORRUPT, zip->zip);
		return -1;
	}

	return 0;
}

/* Read UNcompressed data
   out:
	data UNcompressed data
   return:
	==0 success
	<0 error
*/
int readuncompresszip(ZIP* zip, struct zipent* ent, char* data) {
	if (ent->compression_method == 0x0000) {
		/* file is not compressed, simply stored */

		/* check if size are equal */
		if (ent->compressed_size != ent->uncompressed_size) {
			errormsg("Wrong uncompressed size in store compression", ERROR_CORRUPT,zip->zip);
			return -3;
		}

		return readcompresszip(zip,ent,data);
	} else if (ent->compression_method == 0x0008) {
		/* file is compressed using "Deflate" method */
		if (ent->version_needed_to_extract > 0x14) {
			errormsg("Version too new", ERROR_UNSUPPORTED,zip->zip);
			return -2;
		}

		if (ent->os_needed_to_extract != 0x00) {
			errormsg("OS not supported", ERROR_UNSUPPORTED,zip->zip);
			return -2;
		}

		if (ent->disk_number_start != zip->number_of_this_disk) {
			errormsg("Cannot span disks", ERROR_UNSUPPORTED,zip->zip);
			return -2;
		}

		/* read compressed data */
		if (seekcompresszip(zip,ent)!=0) {
			return -1;
		}

		/* configure inflate */
		if (inflate_file( zip->fp, ent->compressed_size, (unsigned char*)data, ent->uncompressed_size))
		{
			errormsg("Inflating compressed data", ERROR_CORRUPT, zip->zip);
			return -3;
		}

		return 0;
	} else {
		errormsg("Compression method unsupported", ERROR_UNSUPPORTED, zip->zip);
		return -2;
	}
}

/* -------------------------------------------------------------------------
   Zip cache support
 ------------------------------------------------------------------------- */

/* Use the zip cache */
#define ZIP_CACHE

#ifdef ZIP_CACHE

/* ZIP cache entries */
#define ZIP_CACHE_MAX 2

/* ZIP cache buffer LRU ( Last Recently Used )
     zip_cache_map[0] is the newer
     zip_cache_map[ZIP_CACHE_MAX-1] is the older
*/
static ZIP* zip_cache_map[ZIP_CACHE_MAX];

static ZIP* cache_openzip(const char* zipfile) {
	ZIP* zip;
	unsigned i;

	/* search in the cache buffer */
	for(i=0;i<ZIP_CACHE_MAX;++i) {
		if (zip_cache_map[i] && strcmp(zip_cache_map[i]->zip,zipfile)==0) {
			/* found */
			unsigned j;

/*
			logerror("Zip cache HIT  for %s\n", zipfile);
*/

			/* reset the zip directory */
			rewindzip( zip_cache_map[i] );

			/* store */
			zip = zip_cache_map[i];

			/* shift */
			for(j=i;j>0;--j)
				zip_cache_map[j] = zip_cache_map[j-1];

			/* set the first entry */
			zip_cache_map[0] = zip;

			return zip_cache_map[0];
		}
	}
	/* not found */

/*
	logerror("Zip cache FAIL for %s\n", zipfile);
*/

	/* open the zip */
	zip = openzip( zipfile );
	if (!zip)
		return 0;

	/* close the oldest entry */
	if (zip_cache_map[ZIP_CACHE_MAX-1]) {
		/* close last zip */
		closezip(zip_cache_map[ZIP_CACHE_MAX-1]);
		/* reset the entry */
		zip_cache_map[ZIP_CACHE_MAX-1] = 0;
	}

	/* shift */
	for(i=ZIP_CACHE_MAX-1;i>0;--i)
		zip_cache_map[i] = zip_cache_map[i-1];

	/* set the first entry */
	zip_cache_map[0] = zip;

	return zip_cache_map[0];
}

static void cache_closezip(ZIP* zip) {
	unsigned i;

	/* search in the cache buffer */
	for(i=0;i<ZIP_CACHE_MAX;++i) {
		if (zip_cache_map[i]==zip) {
			/* close zip */
			closezip(zip);

			/* reset cache entry */
			zip_cache_map[i] = 0;
			return;

		}
	}
	/* not found */

	/* close zip */
	closezip(zip);
}

/* CK980415 added to allow osd code to clear zip cache for auditing--each time
   the user opens up an audit for a game we should reread the zip */
void unzip_cache_clear()
{
	unsigned i;

	/* search in the cache buffer for any zip info and clear it */
	for(i=0;i<ZIP_CACHE_MAX;++i) {
		if (zip_cache_map[i] != NULL) {
			/* close zip */
			closezip(zip_cache_map[i]);

			/* reset cache entry */
			zip_cache_map[i] = 0;
/*			return; */

		}
	}
}

#define cache_suspendzip(a) suspendzip(a)

#else

#define cache_openzip(a) openzip(a)
#define cache_closezip(a) closezip(a)
#define cache_suspendzip(a) closezip(a)

#define unzip_cache_clear()

#endif

/* -------------------------------------------------------------------------
   Backward MAME compatibility
 ------------------------------------------------------------------------- */

/* Compare two filename
   note:
     don't check directory in zip and ignore case
*/
static int equal_filename(const char* zipfile, const char* file) {
	const char* s1 = file;
	/* start comparison after last / */
	const char* s2 = strrchr(zipfile,'/');
	if (s2)
		++s2;
	else
		s2 = zipfile;
	while (*s1 && toupper(*s1)==toupper(*s2)) {
		++s1;
		++s2;
	}
	return !*s1 && !*s2;
}

/* Pass the path to the zipfile and the name of the file within the zipfile.
   buf will be set to point to the uncompressed image of that zipped file.
   length will be set to the length of the uncompressed data. */
int /* error */ load_zipped_file (const char* zipfile, const char* filename, unsigned char** buf, unsigned int* length, char *unzipfilename) {
	ZIP* zip;
	struct zipent* ent;

	zip = cache_openzip(zipfile);
	if (!zip)
		return -1;

	while (readzip(zip)) {
		/* NS981003: support for "load by CRC" */
		char crc[9];

		ent = &(zip->ent);

		sprintf(crc,"%08x",ent->crc32);

                if((strcmp(&ent->name[strlen(ent->name)-3],"SMS")==0) || (strcmp(&ent->name[strlen(ent->name)-3],"sms")==0) || (strcmp(&ent->name[strlen(ent->name)-2],"GG")==0) || (strcmp(&ent->name[strlen(ent->name)-2],"gg")==0))
                //if (equal_filename(ent->name, filename) || (ent->crc32 && !strcmp(crc, filename)))
		{
                        strcpy(unzipfilename, ent->name);
                        printf("zip: %s\r\n", unzipfilename);
			*length = ent->uncompressed_size;
			*buf = (unsigned char*)malloc( *length );
			if (!*buf) {
				if (!gUnzipQuiet)
					printf("load_zipped_file(): Unable to allocate %d bytes of RAM\n",*length);
				cache_closezip(zip);
				return -1;
			}

			if (readuncompresszip(zip, ent, (char*)*buf)!=0) {
				free(*buf);
				cache_closezip(zip);
				return -1;
			}

			cache_suspendzip(zip);
			return 0;
		}
	}

	cache_suspendzip(zip);
	return -1;
}

/*	Pass the path to the zipfile and the name of the file within the zipfile.
	sum will be set to the CRC-32 of that zipped file. */
/*  The caller can preset sum to the expected checksum to enable "load by CRC" */
int /* error */ checksum_zipped_file (const char *zipfile, const char *filename, unsigned int *length, unsigned int *sum) {
	ZIP* zip;
	struct zipent* ent;

	zip = cache_openzip(zipfile);
	if (!zip)
		return -1;

	while (readzip(zip)) {
		ent = &(zip->ent);

		if (equal_filename(ent->name, filename))
		{
			*length = ent->uncompressed_size;
			*sum = ent->crc32;
			cache_suspendzip(zip);
			return 0;
		}
	}

	cache_suspendzip(zip);

	/* NS981003: support for "load by CRC" */
	zip = cache_openzip(zipfile);
	if (!zip)
		return -1;

	while (readzip(zip)) {
		ent = &(zip->ent);

		if (*sum && ent->crc32 == *sum)
		{
			*length = ent->uncompressed_size;
			*sum = ent->crc32;
			cache_suspendzip(zip);
			return 0;
		}
	}

	cache_suspendzip(zip);
	return -1;
}


uint32 return_1_byte (uint32 val, int position) {
	uint32 temp;

	switch (position) {
		case 0: temp = (val << 28);
				temp = (temp >> 28);
				return temp;
				break;

		case 1:	temp = (val << 24);
				temp = (temp >> 28);
				return temp;
				break;

		case 2: temp = (val << 20);
				temp = (temp >> 28);
				return temp;
				break;

		case 3: temp = (val << 16);
				temp = (temp >> 28);
				return temp;
				break;

		case 4:	temp = (val << 12);
				temp = (temp >> 28);
				return temp;
				break;

		case 5: temp = (val << 8);
				temp = (temp >> 28);
				return temp;
				break;

		case 6: temp = (val << 4);
				temp = (temp >> 28);
				return temp;
				break;

		case 7:	temp = (val >> 28);
				return temp;
				break;
	}
	return (0xFFFFFFFF);

}

char return_hex_char_32 (uint32 val) {
	switch (val) {
		case 0x00000000:
			return '0';
			break;
		case 0x00000001:
			return '1';
			break;
		case 0x00000002:
			return '2';
			break;
		case 0x00000003:
			return '3';
			break;
		case 0x00000004:
			return '4';
			break;
		case 0x00000005:
			return '5';
			break;
		case 0x00000006:
			return '6';
			break;
		case 0x00000007:
			return '7';
			break;
		case 0x00000008:
			return '8';
			break;
		case 0x00000009:
			return '9';
			break;
		case 0x0000000A:
			return 'A';
			break;
		case 0x0000000B:
			return 'B';
			break;
		case 0x0000000C:
			return 'C';
			break;
		case 0x0000000D:
			return 'D';
			break;
		case 0x0000000E:
			return 'E';
			break;
		case 0x0000000F:
			return 'F';
			break;
		}
		return 'Z';		
}
