#ifndef __DCLOAD_SYSCALLS_H__
#define __DCLOAD_SYSCALLS_H__

#define O_RDONLY        0
#define O_WRONLY        1
#define O_RDWR          2

int dcload_link (const char *oldpath, const char *newpath);
int dcload_read (int file, char *ptr, int len);
int dcload_lseek (int file, int ptr, int dir);
int dcload_write ( int file, char *ptr, int len);
int dcload_close (int file);
int dcload_fstat (int file, struct stat *st);
int dcload_open (const char *path, int flags);
int dcload_creat (const char *path, int mode);
int dcload_unlink (const char *path);
void dcload_exit (int status);
int dcload_stat (const char *path, struct stat *st);
int dcload_chmod (const char *path, short mode);
int dcload_utime (const char *path, char *times);
int dcload_chdir (const char *path);
long dcload_time(long *t);
void assign_wrkmem(unsigned char *wrkmem);

#endif
